/**
 * Common js
 */

//mode
var TEST_MODE = true;

//########################################################
// global variable
//########################################################
//server url
var coreServerUrl   = TEST_MODE ? "https://pc-efs.uswest.12cmglobal.com/" : "https://core.elephantfoot.com/";
var mktgServerUrl   = TEST_MODE ? "https://pm-efs.uswest.12cmglobal.com/" : "https://mktg.elephantfoot.com/";
var svcKey          = TEST_MODE ? "d272d76bad563417da46a7db6ff7bc2ed" : "p40bbfaea56494817b2bcc77131943a9a";

//APP INDEX
var AND_IDX = TEST_MODE ? "B" : "A";
var IOS_IDX = TEST_MODE ? "C" : "B";

// get parameter request
function Request(){
    this.getParameter=function(name){
        var rtnval = '';
        var nowAddress=unescape(decodeURI(location.href));
        var parameters=(nowAddress.slice(nowAddress.indexOf('?')+1, nowAddress.length)).split('&');
        for(var i = 0; i<parameters.length; i++){
            var varName=parameters[i].split('=')[0];
            if(varName.toUpperCase() == name.toUpperCase()){
                rtnval=parameters[i].split('=')[1];
                break;
            }
        }
        rtnval = unescape(decodeURIComponent(rtnval));
        return rtnval;
    }
}
var request = new Request();


//############ customer common variable ############ 
var custId = "";
var fname = "";
var email = "";


//############ validation patterns ############
var pattern = [];

//숫자 포함
pattern['num'] = /[0-9]+/;

//영문대문자 포함
pattern['up_eng'] = /[A-Z]+/;

//숫자만 포함
pattern['only_num'] = /^[0-9]+$/;

//영문 대소문자, 숫자 포함
pattern['engnum'] = /^[a-zA-Z0-9]*$/;

//영문자 포함
pattern['eng'] = /^[a-zA-Z]+$/;
pattern['eng_f'] = /^[ａ-ｚＡ-Ｚ]^/;
//이메일 체크
pattern['email'] = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
//비밀번호 체크
pattern['passwd'] = /[^0-9a-zA-Z0-9!#$%&’*+/=?^_`{|}~.-]+/;



//########################################################
// echoss Hybrid
//########################################################
var bAndroidDevice = null;
function isAndroidDevice() {
	if (bAndroidDevice === null) {
		var ua = "" + navigator.userAgent;
		if (ua.toUpperCase().indexOf('IPHONE') != -1 || ua.toUpperCase().indexOf('IPAD') != -1) {
			bAndroidDevice = false;
		} else {
			bAndroidDevice = true;
		}
	}
	return bAndroidDevice;
}

//데이터 파일에서 읽어오기
function echossLoadData(keyStr) {
	var value = null;
	if (isAndroidDevice()) {
		value = window.Android.echossLoadData(keyStr);
	} else {
        value = echossHybrid.echossLoadData(keyStr);
	}

    if(value == undefined || value == null)
        value = "";
    
	return value;
}

//데이터 파일에서 쓰기
function echossSaveData(keyStr, valueStr) {
	if (isAndroidDevice()) {
		window.Android.echossSaveData(keyStr, valueStr);
	} else {
        echossHybrid.echossSaveDataWithValue(keyStr, valueStr);
	}
}

//데이터 메모리에서 읽어오기 (앱 종료시 삭제)
function echossGetData(keyStr) {
	var value = null;
	if (isAndroidDevice()) {
		value = window.Android.echossGetData(keyStr);
	} else {
        value = echossHybrid.echossGetData(keyStr);
	}
	
	if(value == undefined || value == null)
        value = "";
	
	return value;
}

//데이터 메모리에 쓰기 (앱 종료시 삭제)
function echossPutData(keyStr, valueStr) {
	if (isAndroidDevice()) {
		window.Android.echossPutData(keyStr, valueStr);
	} else {
		echossHybrid.echossPutDataWithValue(keyStr, valueStr);
	}	
}
                        
//로컬 타임존 가져오기
function echossGetTimezone() {
    var value = null;
    if (isAndroidDevice())
        value = window.Android.echossGetTimezone();
    else
        value = echossHybrid.echossGetTimezone();

    if(value == undefined || value == null)
        value = "";

    return value;
}

// Web 로그를 APP에 노출
function echossLog(message) {
	if (isAndroidDevice()) {
		console.log(message);
	} else {
		alert("LOG : " + message);
	}
}

// 외부 브라우저로 URL 실행
function echossOpenLinkExternally(url) {
    if (isAndroidDevice()) {
        window.Android.echossOpenLinkExternally(url);
    } else {
        echossHybrid.echossOpenLinkExternally(url);
    }
}

// 위치정보 획득 여부 확인
function echossCheckLocation() {
    if (isAndroidDevice()) {
        return window.Android.echossCheckLocation();
    }
    else {
        return echossHybrid.echossCheckLocation();
    }
}

//위치정보 획득 가능 여부 확인
function echossGetLocationStatus() {
    if (isAndroidDevice()) {
        return window.Android.echossGetLocationStatus();
    }
    else {
        return echossHybrid.echossGetLocationStatus();
    }
}

function echossCleanView() {
    if (isAndroidDevice()) {
        return window.Android.echossCleanView();
    }
    else {
        return echossHybrid.echossCleanView();
    }
}
                        
//로컬 타임존 가져오기
function echossGetTimezone() {
    var value = null;
    if (isAndroidDevice()) {
        value = window.Android.echossGetTimezone();
    } else {
        value = echossHybrid.echossGetTimezone();
    }

    if(value == undefined || value == null)
        value = "";

    return value;
}

function echossShowPage(urlData) {
    location.href = "elephantfootstamp://showPage?" + urlData;
}

function echossDismissPage() {
    location.href = "elephantfootstamp://dismissPage";
}

function echossGetparams(callback) {
    location.href = "elephantfootstamp://getparams?" + callback;
}

// Web과 앱을 연동하는 Context 생성 함수
function echossInitJavaScriptContext() {
	location.href = "elephantfootstamp://initJSContext";
}

// 스탬프 사운드 플레이
function echossPlaySound() {
    location.href = "elephantfootstamp://playSound";
}

// 전화 앱을 실행
function echossCall(number) {
    location.href = "elephantfootstamp://callPhone?" + number;
}

// 위치정보 권한을 습득 및 위치 리스너 실행
function echossRequestLocationPermission() {
    location.href = "elephantfootstamp://requestLocationPermission";
}

// 기기의 위치정보 설정 화면으로 이동
function echossRequestLocationSetting() {
	location.href = "elephantfootstamp://showlocationsetting";
}

function echossTerminateApplication() {
    location.href = "elephantfootstamp://terminateApp";
}
                        
// 안드로이드 백버튼 클릭 시 뒤로가기
function onPrev() {
    echossDismissPage();
}


//########################################################
// common function
//########################################################
//left padding
function leftPad(s, c, n) {   
    if (! s || ! c || s.length >= n) {
        return s;
    }
 
    var max = (n - s.length)/c.length;
    for (var i = 0; i < max; i++) {
        s = c + s;
    }
    return s;
}
 
//right padding
function rightPad(s, c, n) { 
    if (! s || ! c || s.length >= n) {
        return s;
    }
 
    var max = (n - s.length)/c.length;
    for (var i = 0; i < max; i++) {
        s += c;
    }
    return s;
}

function isDate(txtDate) {
	var currVal = txtDate;
	if(currVal == '') 
		return false;

	//Declare Regex 
	var rxDatePattern = /^(\d{1,2})(\d{1,2})(\d{4})$/;
	var dtArray = currVal.match(rxDatePattern); // is format OK?

	if (dtArray == null) 
		return false;

	//Checks for mm/dd/yyyy format.
	dtMonth = dtArray[1];
	dtDay= dtArray[3];
	dtYear = dtArray[5];

	if (dtMonth < 1 || dtMonth > 12)
		return false;
	else if (dtDay < 1 || dtDay> 31)
		return false;
	else if ((dtMonth==4 || dtMonth==6 || dtMonth==9 || dtMonth==11) && dtDay ==31)
		return false;
	else if (dtMonth == 2)
	{
		var isleap = (dtYear % 4 == 0 && (dtYear % 100 != 0 || dtYear % 400 == 0));
		if (dtDay> 29 || (dtDay ==29 && !isleap))
			return false;
	}
	return true;
}

function strip_tags(html){

    //PROCESS STRING
    if(arguments.length < 3) {
        html=html.replace(/<\/?(?!\!)[^>]*>/gi, '');
    } else {
        var allowed = arguments[1];
        var specified = eval("["+arguments[2]+"]");
        if(allowed){
            var regex='</?(?!(' + specified.join('|') + '))\b[^>]*>';
            html=html.replace(new RegExp(regex, 'gi'), '');
        } else{
            var regex='</?(' + specified.join('|') + ')\b[^>]*>';
            html=html.replace(new RegExp(regex, 'gi'), '');
        }
    }
    //CHANGE NAME TO CLEAN JUST BECAUSE
    var clean_string = html;
    //RETURN THE CLEAN STRING
    return clean_string;
}
                        
function requestAjax(params, url, method, success, failed, isSpinnerLoad) {
    if( isSpinnerLoad == undefined )
        spinner_load();

    var xmlhttp;
    if (window.XMLHttpRequest)
        xmlhttp = new XMLHttpRequest();
    else
        xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");

    xmlhttp.onreadystatechange = function() {
        if (xmlhttp.readyState === 4 ) {
            if( isSpinnerLoad == undefined )
                spinner_load_stop();

            if(xmlhttp.status === 200){
                var request = JSON.parse(xmlhttp.response);
                if (request.resCd === "0000") {
                    if( success != undefined )
                        success(request.result);
                }
                else {
                    if( failed != undefined )
                        failed(request);
                    else
                        showAlert("Error", "["+request.resCd+"]"+request.resMsg, "Confirm");
                }
            }
            else {
                showAlert("Error", "Network is unstable. Please check out your connection status.", "Confirm");
            }
        }
    }
              
    if (params === undefined)
        params = {};

    params.key          = svcKey;
    params.timezoneId   = echossGetTimezone();
    params.lang         = "en";

    if( method == "POST" || method == "PUT" || method == "DELETE" ) {
        xmlhttp.open(method, url, true);
                        
        xmlhttp.setRequestHeader("Content-type", "application/json");
        xmlhttp.setRequestHeader("Accept", "application/json");
        xmlhttp.setRequestHeader("Authorization", "Basic " + btoa("45bbe9f4-583f-40e0-9753-463941534346:61353066643233312D393161392D343532372D626264652D323836373338633533616630"));

        xmlhttp.send(JSON.stringify(params));
    }
    else {
        var paramsKeys = Object.keys(params);
        for (var i=0; i<paramsKeys.length; i++) {
            if (params.hasOwnProperty(paramsKeys[i])) {
                if( i==0 )
                    url += ("?" + paramsKeys[i] + "=" + params[paramsKeys[i]]);
                else
                    url += ("&" + paramsKeys[i] + "=" + params[paramsKeys[i]]);
            }
        }
                        
        xmlhttp.open(method, url, true);
                        
        xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
        xmlhttp.setRequestHeader("Accept", "application/json");
        xmlhttp.setRequestHeader("Authorization", "Basic " + btoa("45bbe9f4-583f-40e0-9753-463941534346:61353066643233312D393161392D343532372D626264652D323836373338633533616630"));
                        
        xmlhttp.send(null);
    }
}

/** Validation Functions */
// 공백 문자의 유무 확인
function hasWhiteSpace(s) {
    return /\s/g.test(s);
}

/** Move Functions */
function goHome() {
    echossCleanView();
	location.href = "home.html";
}

//메인화면
function goMain() {
    echossCleanView();
	location.href = "main.html";
}

//매장화면
function goStores() {
    echossCleanView();
	location.href = "stores.html";
}

//근처매장화면
function goNearbyStores() {
    echossCleanView();
	location.href = "nearby_stores.html";
}

//내쿠폰 화면
function goMyCoupons() {
    echossCleanView();
	location.href = "my_coupons.html";
}
                        
// Favorite Stamp Cards
function goFavoriteStampCards(){
    echossCleanView();
    location.href = "my_favorite_stamp_events.html";
}
                        
function goInbox(){
    echossCleanView();
    location.href = "inbox.html";
}

//stamp history 화면
function goStampHistory() {
    echossCleanView();
	location.href = "stamp_history.html";
}

//회원정보수정
function goProfile() {
	echossShowPage('STAMP/edit_profile.html');
}

//비밀번호변경
function goChgPassword() {
	echossShowPage('STAMP/change_password.html');
}

//비밀번호 찾기
function goFindPassword() {
    echossShowPage('STAMP/forgot_password.html');
}

//로그인화면
function goSignIn() {
    echossShowPage('STAMP/login.html');
}

//회원가입화면
function goSignUp() {
    echossShowPage('STAMP/sign_up.html');
}
                            
//매장 상세 페이지
function goStoreDetail(store_id) {
	echossShowPage('STAMP/store_detail.html?store_id='+store_id);
}

//스탬프카드 페이지
function goStampCard(funcKey) {
    echossShowPage('STAMP/stamp_detail.html?funckey='+funcKey);
}

//룰렛 페이지
function goRoulette(funcKey) {
	echossShowPage('STAMP/roulette_event.html?funckey='+funcKey);
}
      
//랠리 페이지
function goStampRally(funcKey) {
    echossShowPage('STAMP/rally.html?funckey='+funcKey);
}

//소개
function goAbout() {
	echossShowPage('STAMP/about.html');
}

//약관
function goTerms(moveBack) {
    if( moveBack != undefined )
        echossShowPage('STAMP/terms.html?moveBack='+moveBack);
    else
        echossShowPage('STAMP/terms.html');
}

//개인정보
function goPolicy(moveBack) {
    if( moveBack != undefined )
        echossShowPage('STAMP/policy.html?moveBack='+moveBack);
    else
        echossShowPage('STAMP/policy.html');
}

//이벤트배너상세
function goEventDetail() {
	echossShowPage('STAMP/events_detail.html');
}

//검색화면
function goSearch() {
	echossShowPage('STAMP/search.html');
}
                            
//스택지우면서 메인으로 가기
function cleanView() {
    location.href = "main.html";
    echossCleanView();
}

//로그인 알럿
function loginAlert(userValue) {
	if(userValue == "" || userValue == undefined) {
		showConfirm("sign in", "You need to sign in to continue.", "Cancel", "Ok", function() {

		}, function() {
			goSignIn();
		});
		return;
	}
}


/**
 * util functions
 */
// 입력된 문자의 maxLength Check
function maxLengthCheck(object){
    if (object.value.length > object.maxLength){
        object.value = object.value.slice(0, object.maxLength);
    }
}

function formatnumber(v1,v2){
    var str = new Array();
    v1 = String(v1);
    for(var i=1;i<=v1.length;i++){
        if(i % v2) str[v1.length-i] = v1.charAt(v1.length-i);
        else str[v1.length-i] = ','+v1.charAt(v1.length-i);
    }
    return str.join('').replace(/^,/,'');
}

//날짜 포맷 - formatDate(obj.expDate, '-', 'No expiry date')
function formatDate(dateStr, delim, defaultStr) {
	if( defaultStr != undefined && dateStr.length <= 0 )
		return defaultStr;
	var dateString = "";
	var year = dateStr.substr(0, 4);
	var month = dateStr.substr(4, 2);
	var day = dateStr.substr(6, 2);
	dateString = year + delim + month + delim + day;
	return dateString;
}

/*loading_spinner*/
function spinner_load() {
    if( document.getElementById('load_wrap') != null )
        return;

    var spinner_html = "";
    spinner_html+=" <div id='load_inner' class='load_inner'>";
    spinner_html+="     <div class='loading_img'>";
    spinner_html+="     <img class='fix_img' src='images/load_center.png' alt='load_img' />";
    spinner_html+="         <div id='l_arrow'></div>";
    spinner_html+="     </div>";
    spinner_html+="     <p>Powered by Echoss</p>";
    spinner_html+=" </div>";
             
    var node = document.createElement("div");
    node.id = "load_wrap";
    node.classList.add("load_wrap");
    node.innerHTML = spinner_html;
    document.body.appendChild(node);
}

function spinner_load_stop(){
    if( document.getElementById('load_wrap') != null )
        document.getElementById('load_wrap').remove();
}

function isBlank(obj) {
	if(obj == "" || obj == "null" || obj == null || obj == "undefined" || obj == undefined) {
		return true;
	}
}

function showInputPassword(iconId, fieldId) {
    if( document.getElementById(iconId).classList.contains("on") ) {
        document.getElementById(iconId).classList.remove("on");
        document.getElementById(fieldId).setAttribute("type", "password");
    }
    else {
        document.getElementById(iconId).classList.add("on");
        document.getElementById(fieldId).setAttribute("type", "text");
    }
}

function onResetPage() {

}

function signOutMenu(email) {
    if(email == undefined || email == null || email == "") {
        return "- Sign out";
    }

    var maxLen = 25;
    if(email.length > maxLen) {
        return "- Sign out(" + email.substr(0, maxLen) + "...)";
    }
    else {
        return "- Sign out(" + email + ")";
    }
}

function loadTabMenu() {
    var tabMenu = "";
    tabMenu += "    <div class=\"tab_menu_upper\">";
    tabMenu += "        <img class=\"menu_logo\" src=\"images/main_logo.png\" alt=\"main_logo\" />";
    tabMenu += "        <div id=\"info\" class=\"info\" style='margin-top: 3%;'>";
    tabMenu += "            <div id=\"login_before\">";
    tabMenu += "                <p style='font-size: 0.95rem; '>Hi!</p>";
    tabMenu += "                <a class=\"sign_in\" onclick='goSignIn();' style='line-height: 1; padding: 5px;'>Sign In</a>";
    tabMenu += "                <a class=\"sign_up\" onclick='goSignUp();' style='line-height: 1; padding: 5px;'>Sign Up</a>";
    tabMenu += "            </div>";
    tabMenu += "            <div id=\"login_after\">";
    tabMenu += "                <p class=\"login_after_text\">Hi! <span id=\"loginName\"></span></p>";
    tabMenu += "            </div>";
    tabMenu += "        </div>";
    tabMenu += "        <a onclick='goMain();'><span class=\"get_stamped\">Home</span></a>";
    tabMenu += "        <ul class=\"menu_list\">";
    tabMenu += "            <li id=\"left_home\" class=\"home\"><p>Events</p></li>";
    tabMenu += "            <li id=\"left_stores\" class=\"stores\"><p>Stores</p></li>";
    tabMenu += "            <li id=\"left_nearby_stores\" class=\"nearby_stores\"><p>Nearby Stores</p></li>";
    tabMenu += "            <li id=\"left_coupons\" class=\"coupons\"><p>My Coupons</p></li>";
    tabMenu += "            <li id=\"my_favorite_stamp_cards\"><p>My Favorite Stamp Cards</p></li>";
    tabMenu += "            <li id=\"inbox\"><p>Inbox<span class='notification_icon'><span id='inbox_badge_count' style='display: none;'></span></span></p></li>";
    tabMenu += "            <li id=\"left_history\" class=\"history\"><p>Stamp History</p>\</li>";
    tabMenu += "        </ul>";
    tabMenu += "        <img id=\"setting\" src=\"images/ico_setting.png\" alt=\"ico_setting\" onclick=\"setmenuOpen(this);\"/>";
    tabMenu += "        <div class=\"bottom_desc\">";
    tabMenu += "            <p class=\"ver\">";
    tabMenu += "                Current Ver. <span id=\"currAppver\"></span><br/>";
    tabMenu += "                Latest Ver. <span id=\"lastAppver\"></span></p>";
    tabMenu += "            <p>Powered by Echoss</p>"
    tabMenu += "            <span id=\"appUpdate\" class=\"update\">Update</span>";
    tabMenu += "        </div>";
    tabMenu += "    </div>";

    var node = document.createElement("div");
    node.id = "tab_menu";
    node.classList.add("tab_menu_wrap");
    node.innerHTML = tabMenu;
    document.getElementById("container").appendChild(node);

    tabMenu = "";
    tabMenu += "    <div class=\"tab_set_menu_upper\">";
    tabMenu += "        <div class=\"set_meun_top\">";
    tabMenu += "            <p class=\"set_menu_tit\">Setting Menu</p>";
    tabMenu += "            <img id=\"btn_back\" class=\"back_ico\" src=\"images/ico_back.png\" alt=\"ico_setting\" onclick=\"setmenuClose(this);\" />";
    tabMenu += "        </div>";
    tabMenu += "        <div class=\"set_list_wrap\">";
    tabMenu += "            <div class=\"set_list_upper\">";
    tabMenu += "                <div class=\"menu_inner\">";
    tabMenu += "                    <span id=\"account\" class=\"main_list\">ACCOUNT<span><br/>Customer Code: <span id='menu_customer_code'>"+echossLoadData('custCode')+"</span></span></span>";
    tabMenu += "                    <span id=\"profile\" class=\"sub_list\">- Edit Profile</span>";
    tabMenu += "                    <span id=\"change_password\" class=\"sub_list\">- Change Password</span>";
    tabMenu += "                </div>";
    tabMenu += "                <div class=\"menu_inner\">";
    tabMenu += "                    <span id=\"preferences\" class=\"main_list\">PREFERENCES</span>";
    tabMenu += "                    <span id='push_switch_area' class=\"sub_list\">- Message Notifications<span id='push_switch_button' class='switch_area'></span></span>";
    tabMenu += "                    <span id='sound_switch_area' class=\"sub_list\">- Sound on Stamping<span id='sound_switch_button' class=\"switch_area\"></span></span>";
    tabMenu += "                </div>";
    tabMenu += "                <div class=\"menu_inner\">";
    tabMenu += "                    <span id=\"about\" class=\"main_list\">ABOUT</span>";
    tabMenu += "                    <span id=\"elpfoot_stamp\" class=\"sub_list\">- About Elephant Foot Stamp</span>";
    tabMenu += "                    <span id=\"terms_of_use\" class=\"sub_list\">- Terms of Use</span>";
    tabMenu += "                    <span id=\"privacy_policy\" class=\"sub_list\">- Privacy Policy</span>";
    tabMenu += "                    <span id=\"sign_out\" class=\"sub_list\" style=\"display:none;\"></span>";
    tabMenu += "                </div>";
    tabMenu += "            </div>";
    tabMenu += "        </div>";
    tabMenu += "    </div>";

    node = document.createElement("div");
    node.id = "tab_set_menu";
    node.classList.add("tab_set_menu_wrap");
    node.innerHTML = tabMenu;
    document.getElementById("container").appendChild(node);

    if( echossLoadData("noReadMsgCnt") != "" && echossLoadData("noReadMsgCnt") > 0 ) {
        document.getElementById('inbox_badge_count').style.display = "inline-block";
        document.getElementById('inbox_badge_count').innerHTML = echossLoadData("noReadMsgCnt");
    }
    else
        document.getElementById('inbox_badge_count').style.display = "none";
                        
    // tab menu 터치 스와이프 기능
    $('#tab_menu').slideAndSwipe();

    document.getElementById('currAppver').innerHTML = echossLoadData("appVer");
    document.getElementById('lastAppver').innerHTML = echossLoadData("lstAppVer");

    if(!isBlank(fname)) {
        document.getElementById('loginName').innerHTML = fname;
        document.getElementById('sign_out').innerHTML = signOutMenu(email);
        document.getElementById('sign_out').style.display = "block";
        document.getElementById('info').classList.add("on");
    }

    // home
    document.getElementById('left_home').addEventListener("click", function() {
        goHome();
    });
                        
    // stores
    document.getElementById('left_stores').addEventListener("click", function() {
        goStores();
    });
                        
    // nearby stores
    document.getElementById('left_nearby_stores').addEventListener("click", function() {
        goNearbyStores();
    });
                        
    // my coupons
    document.getElementById('left_coupons').addEventListener("click", function() {
        if(isBlank(fname)) {
            showConfirm("sign in", "You need to sign in to continue.", "Cancel", "Ok", function() {
                //goMyCoupons();
            }, function() {
                goSignIn();
            });
        }
        else {
            goMyCoupons();
        }
    });
                        
    // my favorite stamp cards
    document.getElementById('my_favorite_stamp_cards').addEventListener("click", function() {
        if(isBlank(fname)) {
            showConfirm("sign in", "You need to sign in to continue.", "Cancel", "Ok", function() {
                //goFavoriteStampCards();
            }, function() {
                goSignIn();
            });
        }
        else {
            goFavoriteStampCards();
        }
    });
                        
    // my favorite stamp cards
    document.getElementById('inbox').addEventListener("click", function() {
       goInbox();

    });
                        
    // stamp history
    document.getElementById('left_history').addEventListener("click", function() {
        goStampHistory();
    });
    // about
    document.getElementById('elpfoot_stamp').addEventListener("click", function() {
        goAbout();
    });
    // terms
    document.getElementById('terms_of_use').addEventListener("click", function() {
        goTerms();
    });
    // policy
    document.getElementById('privacy_policy').addEventListener("click", function() {
        goPolicy();
    });

    // push notification on/off
    if(echossLoadData("pushYn") != "N")
        document.getElementById('push_switch_button').classList.add("on");

    document.getElementById('push_switch_area').addEventListener("click", function() {
        var tempPushYn = ( echossLoadData("pushYn") == "N" ? "Y" : "N" );

        requestAjax({
            id      : custId,
            pushYn  : tempPushYn
        }, coreServerUrl + "csc/customers/pushUpdate", "POST", function (data) {
            echossSaveData("pushYn", tempPushYn);
            document.getElementById('push_switch_button').classList.toggle("on");
        });
    });
                        
    // sound mute on/off
    if(echossLoadData("setMute") == "Y")
        document.getElementById('sound_switch_button').classList.remove("on");
    else
        document.getElementById('sound_switch_button').classList.add("on");

    document.getElementById('sound_switch_area').addEventListener("click", function() {
        if( echossLoadData("setMute") == "Y" ) {
            echossSaveData("setMute", "N");
            document.getElementById('sound_switch_button').classList.add("on");
        }
        else {
            echossSaveData("setMute", "Y");
            document.getElementById('sound_switch_button').classList.remove("on");
        }
    });

    // logout
    document.getElementById('sign_out').addEventListener("click", function() {
        showConfirm("Sign Out", "Are you sure you want to sign out?", "Cancel", "Sign Out", function() {

        }, function() {
            echossSaveData("fname", null);
            echossSaveData("lname", null);
            echossSaveData("email", null);
            echossSaveData("ctn", null);

            requestAjax({
                ctnConfirm  : "N",
                os          : isAndroidDevice() ? "A" : "I",
                equip       : echossLoadData("eqNo"),
                equipNm     : echossLoadData("eqMdlNm"),
                appVer      : echossLoadData("appVer"),
                pushId      : echossLoadData("pushId"),
                pushYn      : echossLoadData("pushYn"),
                divCd       : "1"
            }, coreServerUrl + "csc/customers/generate", "POST", function (data) {
                echossSaveData("custId", data.id);
                echossSaveData("custCode", data.shortId);
                goMain();
            });
        });
    });

    // edit profile
    document.getElementById('profile').addEventListener("click", function() {
        if(isBlank(fname)) {
            showConfirm("sign in", "You need to sign in to continue.", "Cancel", "Ok", function() {

            }, function() {
                echossPutData("redirectUrl", "edit_profile.html");
                goSignIn();
            });
        }
        else {
            goProfile();
        }
    });

    // change password
    document.getElementById('change_password').addEventListener("click", function() {
        if(isBlank(fname)) {
            showConfirm("sign in", "You need to sign in to continue.", "Cancel", "Ok", function() {

            }, function() {
                echossPutData("redirectUrl", "change_password.html");
                goSignIn();
            });
        }
        else {
            goChgPassword();
        }
    });

    // app update
    document.getElementById('appUpdate').addEventListener("click", function() {
        //최신버전이 아닐 경우
        if(parseFloat(echossLoadData("appVer")) < parseFloat(echossLoadData("lstAppVer"))) {
            showConfirm("update", "Not a latest version.<br/>Do you want to update?", "Cancel", "Update", function() {

            }, function() {
                if( isAndroidDevice() )
                    location.href = "elephantfootstamp://showOuterBrowser?market://details?id=com.elephantfoot.stamp";
                else
                    location.href = "elephantfootstamp://showOuterBrowser?itms-apps://itunes.apple.com/app/id1274385128";
            });
        }
        else {
            //최신버전일 경우
            showAlert("update", "This is latest updated version.", "Confirm");
        }
    });
}
                        
if( document.getElementById('btn_prev') != null ) {
    document.getElementById('btn_prev').addEventListener("click", function() {
        echossDismissPage();
    });
}

if( document.getElementById('btn_efs') != null ) {
    document.getElementById('btn_efs').addEventListener("click", function() {
        cleanView();
    });
}
                        
function getPushMessages() {
    var alertTitle = echossGetData("alertTitle");
    var alertBody = echossGetData("alertBody");
    var customLink = echossGetData("customLink");
                        
    echossPutData("alertTitle", "");
    echossPutData("alertBody", "");
    echossPutData("customLink", "");

    echossLog("getPushMessages - " + alertTitle + " / " + alertBody + " / " + customLink);

    showConfirm(alertTitle, alertBody, "Cancel", "Ok", function() {
        //
    }, function() {
        if( customLink == "MAIN" ) {
            goMain();
        }
        if( customLink == "COUPON" ) {
            goMyCoupons();
        }
        if( customLink == "EVENT" ) {
            goHome();
        }
    });
}

Element.prototype.remove = function() {
    this.parentElement.removeChild(this);
}
NodeList.prototype.remove = HTMLCollection.prototype.remove = function() {
    for(var i = this.length - 1; i >= 0; i--) {
        if(this[i] && this[i].parentElement) {
            this[i].parentElement.removeChild(this[i]);
        }
    }
}
